package com.example.supabaserebuild.View.Components

import androidx.compose.foundation.layout.Arrangement
import androidx.compose.foundation.layout.Column
import androidx.compose.foundation.layout.padding
import androidx.compose.material3.Button
import androidx.compose.material3.Text
import androidx.compose.material3.TextField
import androidx.compose.runtime.Composable
import androidx.compose.runtime.getValue
import androidx.compose.runtime.mutableStateOf
import androidx.compose.runtime.remember
import androidx.compose.runtime.setValue
import androidx.compose.ui.Alignment
import androidx.compose.ui.Modifier
import androidx.compose.ui.text.TextStyle
import androidx.compose.ui.text.input.PasswordVisualTransformation
import androidx.compose.ui.text.input.VisualTransformation
import androidx.compose.ui.tooling.preview.Preview
import androidx.compose.ui.unit.dp
import androidx.compose.ui.unit.sp
import com.example.supabaserebuild.View.MainViewModel

@Preview
@Composable
fun AuthScreen(viewModel: MainViewModel = MainViewModel()) {
    val email = remember { mutableStateOf("")}
    val password = remember { mutableStateOf("")}

    Column(
        Modifier.padding(top = 30.dp, start = 15.dp, end = 15.dp),
        verticalArrangement = Arrangement.Center,
        horizontalAlignment = Alignment.CenterHorizontally
    ) {
        //Поле для ввода email
        TextField(
            value = email.value,
            onValueChange = { newText -> email.value = newText },
            label = { Text("Email") },
            textStyle = TextStyle(fontSize = 18.sp),
            modifier = Modifier.padding(bottom = 16.dp)
        )
            //Поле для ввода пароля с возможностью отображения/скрытия
            var passwordVisibility by remember { mutableStateOf(false) }
            TextField(
                value = password.value,
                onValueChange = { newText -> password.value = newText },
                label = { Text("Password") },
                visualTransformation = if (passwordVisibility) VisualTransformation.None else PasswordVisualTransformation(),
                textStyle = TextStyle(fontSize = 18.sp),
                modifier = Modifier.padding(bottom = 16.dp)
            )

        //Кнопка для входа
        Button(
            onClick = {
                viewModel.onSignInEmailPassword(email.value, password.value)
            },
            modifier = Modifier.padding(bottom = 8.dp)
        ) {
            Text("Sign In", fontSize = 18.sp)
        }

//        //Кнопка для регистрации
//        Button(
//            onClick = {
//                viewModel.onSignUpEmail)
//            } {
//
//        }
    }
}